.\"	$NetBSD: ldconfig.8,v 1.14 2002/10/01 13:40:34 wiz Exp $
.\"
.\" Copyright (c) 1998 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Paul Kranenburg.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 8, 2000
.Dt LDCONFIG 8
.Os
.Sh NAME
.Nm ldconfig
.Nd configure the a.out shared library cache
.Sh SYNOPSIS
.Nm ldconfig
.Op Fl cmrsSv
.Op Ar directory Ar ...
.Sh DESCRIPTION
.Nm
is used to prepare a set of
.Dq hints
for use by the a.out run-time linker
.Nm ld.so
to facilitate quick lookup of shared libraries available in multiple
directories.
.Nm
is only available on systems that use the
.Dq a.out
format for executables and libraries \(en on ELF systems, all the work
is done by
.Nm ld.elf_so .
.Pp
By default, it scans a set of built-in system directories,
directories listed in
.Pa /etc/ld.so.conf ,
and any
.Ar directories
specified on the command line (in the given order) looking for shared
libraries and stores the results in the file
.Pa /var/run/ld.so.hints
to forestall the overhead that would otherwise result from the
directory search operations
.Nm ld.so
would have to perform to load required shared libraries.
.Pp
The shared libraries so found will be automatically available for loading
if needed by the program being prepared for execution.
This obviates the need for storing search paths within the executable.
.Pp
The
.Ev LD_LIBRARY_PATH
environment variable can be used to override the use of
directories (or the order thereof) from the cache or to specify additional
directories where shared libraries might be found.
.Ev LD_LIBRARY_PATH
is a
.Sq \&:
separated list of directory paths that are searched by
.Nm ld.so
when it needs to load a shared library.
It can be viewed as the run-time equivalent of the
.Fl L
switch of
.Nm ld .
.Pp
.Nm
is typically run as part of the boot sequence.
.Pp
The following options are recognized by
.Nm ldconfig :
.Bl -tag -width indent
.It Fl c
Do not scan directories listed in
.Pa /etc/ld.so.conf
for shared libraries.
.It Fl m
Merge the result of the scan of the directories given as arguments into
the existing hints file.
The default action is to build the hints file afresh.
.It Fl r
Lists the current contents of
.Pa ld.so.hints
on the standard output.
The hints file will not be modified.
.It Fl s
Do not scan the built-in system directory
.Pq Pa /usr/lib ,
nor any directories listed in
.Pa /etc/ld.so.conf
for shared libraries.
.It Fl S
Do not scan the built-in system directory
.Pq Pa /usr/lib ,
for shared libraries.
(Directories listed in
.Pa /etc/ld.so.conf
are still scanned.)
.It Fl v
Switch on verbose mode.
.El
.Sh FILES
.Pa /var/run/ld.so.hints ,
.Pa /etc/ld.so.conf
.Sh SEE ALSO
.Xr ld 1 ,
.Xr ld.so 1 ,
.Xr ld.so.conf 5 ,
.Xr link 5
.Sh HISTORY
A
.Nm
utility first appeared in SunOS 4.0, it appeared in its current form
in
.Nx 0.9a .
.Sh SECURITY CONSIDERATIONS
Special care must be taken when loading shared libraries into the address
space of
.Em set-user-ID
programs.
Whenever such a program is run,
.Nm ld.so
will only load shared libraries from the
.Pa ld.so.hints
file.
In particular, the
.Ev LD_LIBRARY_PATH
and
.Ev LD_PRELOAD
is not used to search for libraries.
Thus, the role of ldconfig is dual.
In addition to building a set of hints for quick lookup, it also serves to
specify the trusted collection of directories from which shared objects can
be safely loaded.
It is presumed that the set of directories specified to
.Nm
is under control of the system's administrator.
.Nm ld.so
further assists set-user-ID programs by erasing the
.Ev LD_LIBRARY_PATH
and
.Ev LD_PRELOAD
from the environment.
